using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_SeatGroup
    /// </summary>
    public partial class T_Sys_SeatGroup
    {
        public T_Sys_SeatGroup()
        { }
        #region  BasicMethod


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_SeatGroup model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_SeatGroup(");
            strSql.Append("F_ZXZCode,F_ZXZName,F_IVRKey,F_WHBDKey,F_WHWDKey,F_ZXAtt,F_Des,F_CreateTime,F_CreateBy,F_CreateByName)");
            strSql.Append(" values (");
            strSql.Append("@F_ZXZCode,@F_ZXZName,@F_IVRKey,@F_WHBDKey,@F_WHWDKey,@F_ZXAtt,@F_Des,@F_CreateTime,@F_CreateBy,@F_CreateByName)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ZXZCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ZXZName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IVRKey", SqlDbType.Int,4),
                    new SqlParameter("@F_WHBDKey", SqlDbType.NChar,10),
                    new SqlParameter("@F_WHWDKey", SqlDbType.NChar,10),
                    new SqlParameter("@F_ZXAtt", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Des", SqlDbType.NText),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateByName", SqlDbType.NVarChar,50)};
            parameters[0].Value = model.F_ZXZCode;
            parameters[1].Value = model.F_ZXZName;
            parameters[2].Value = model.F_IVRKey;
            parameters[3].Value = model.F_WHBDKey;
            parameters[4].Value = model.F_WHWDKey;
            parameters[5].Value = model.F_ZXAtt;
            parameters[6].Value = model.F_Des;
            parameters[7].Value = model.F_CreateTime;
            parameters[8].Value = model.F_CreateBy;
            parameters[9].Value = model.F_CreateByName;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_SeatGroup model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_SeatGroup set ");
            strSql.Append("F_ZXZCode=@F_ZXZCode,");
            strSql.Append("F_ZXZName=@F_ZXZName,");
            strSql.Append("F_IVRKey=@F_IVRKey,");
            strSql.Append("F_WHBDKey=@F_WHBDKey,");
            strSql.Append("F_WHWDKey=@F_WHWDKey,");
            strSql.Append("F_ZXAtt=@F_ZXAtt,");
            strSql.Append("F_Des=@F_Des,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_CreateByName=@F_CreateByName");
            strSql.Append(" where F_ZXZID=@F_ZXZID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ZXZCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ZXZName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IVRKey", SqlDbType.Int,4),
                    new SqlParameter("@F_WHBDKey", SqlDbType.NChar,10),
                    new SqlParameter("@F_WHWDKey", SqlDbType.NChar,10),
                    new SqlParameter("@F_ZXAtt", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Des", SqlDbType.NText),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateByName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ZXZID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_ZXZCode;
            parameters[1].Value = model.F_ZXZName;
            parameters[2].Value = model.F_IVRKey;
            parameters[3].Value = model.F_WHBDKey;
            parameters[4].Value = model.F_WHWDKey;
            parameters[5].Value = model.F_ZXAtt;
            parameters[6].Value = model.F_Des;
            parameters[7].Value = model.F_CreateTime;
            parameters[8].Value = model.F_CreateBy;
            parameters[9].Value = model.F_CreateByName;
            parameters[10].Value = model.F_ZXZID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ZXZID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_SeatGroup ");
            strSql.Append(" where F_ZXZID=@F_ZXZID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ZXZID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ZXZID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_ZXZIDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_SeatGroup ");
            strSql.Append(" where F_ZXZID in (" + F_ZXZIDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_SeatGroup GetModel(int F_ZXZID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ZXZID,F_ZXZCode,F_ZXZName,F_IVRKey,F_WHBDKey,F_WHWDKey,F_ZXAtt,F_Des,F_CreateTime,F_CreateBy,F_CreateByName from T_Sys_SeatGroup ");
            strSql.Append(" where F_ZXZID=@F_ZXZID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ZXZID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ZXZID;

            CallCenterApi.Model.T_Sys_SeatGroup model = new CallCenterApi.Model.T_Sys_SeatGroup();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_SeatGroup DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_SeatGroup model = new CallCenterApi.Model.T_Sys_SeatGroup();
            if (row != null)
            {
                if (row["F_ZXZID"] != null && row["F_ZXZID"].ToString() != "")
                {
                    model.F_ZXZID = int.Parse(row["F_ZXZID"].ToString());
                }
                if (row["F_ZXZCode"] != null)
                {
                    model.F_ZXZCode = row["F_ZXZCode"].ToString();
                }
                if (row["F_ZXZName"] != null)
                {
                    model.F_ZXZName = row["F_ZXZName"].ToString();
                }
                if (row["F_IVRKey"] != null && row["F_IVRKey"].ToString() != "")
                {
                    model.F_IVRKey = int.Parse(row["F_IVRKey"].ToString());
                }
                if (row["F_WHBDKey"] != null)
                {
                    model.F_WHBDKey = row["F_WHBDKey"].ToString();
                }
                if (row["F_WHWDKey"] != null)
                {
                    model.F_WHWDKey = row["F_WHWDKey"].ToString();
                }
                if (row["F_ZXAtt"] != null)
                {
                    model.F_ZXAtt = row["F_ZXAtt"].ToString();
                }
                if (row["F_Des"] != null)
                {
                    model.F_Des = row["F_Des"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_CreateBy"] != null && row["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(row["F_CreateBy"].ToString());
                }
                if (row["F_CreateByName"] != null)
                {
                    model.F_CreateByName = row["F_CreateByName"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ZXZID,F_ZXZCode,F_ZXZName,F_IVRKey,F_WHBDKey,F_WHWDKey,F_ZXAtt,F_Des,F_CreateTime,F_CreateBy,F_CreateByName ");
            strSql.Append(" FROM T_Sys_SeatGroup ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ZXZID,F_ZXZCode,F_ZXZName,F_IVRKey,F_WHBDKey,F_WHWDKey,F_ZXAtt,F_Des,F_CreateTime,F_CreateBy,F_CreateByName ");
            strSql.Append(" FROM T_Sys_SeatGroup ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_SeatGroup ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ZXZID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_SeatGroup T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }
        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
